﻿--
-- 
--@author Bluebaby210 www.mod-portal.com
--@date: 08.06.2013
--
--@version:		v1.0 Mischungsverhältnis des Mischwagens richtig einstellen. Wenn zu 97% gefüllt und kein richtiges Verhältnis
--
--

FFLMixerWagon = {};

print("Full Fill Level Mixer Wagon was loaded!");
function FFLMixerWagon.prerequisitesPresent(specializations)
	return true;
end;

function FFLMixerWagon:load(xmlFile)
		self.isSelectable = true;
		self.allowedHigherFillLevel = false;
		self.fullPercentage = 0;
		self.factorPercentage = 0;
		self.abort = false;
		self.notEasy = false;
		self.properMixtureRatio = false;
		
		self.middlePercentageFillTypes = {};
			for i=1, table.getn(self.mixerWagonFillTypes) do
				local minPercantage = self.mixerWagonFillTypes[i].minPercentage;
				table.insert(self.middlePercentageFillTypes, minPercantage);
				self.fullPercentage = self.fullPercentage + minPercantage;
			end;
			
		self.factorPercentage = 1/self.fullPercentage;
		
		if self.factorPercentage ~= 1 then
			self.notEasy = true;
			self.middlePercentageFillTypes = nil;
			self.factorPercentage = 0;
			self.fullPercentage = 0;
		end;
		
		--die Min % zusammen ergeben nicht 100%, wäre ja auch zu Leicht...;-)
		if self.notEasy then
			self.middlePercentageLevelFillTypes = {};
			for i=1, table.getn(self.mixerWagonFillTypes) do
				local difference = (self.mixerWagonFillTypes[i].maxPercentage - self.mixerWagonFillTypes[i].minPercentage)/2;
				local middlePercentage = self.mixerWagonFillTypes[i].minPercentage + difference;
				table.insert(self.middlePercentageLevelFillTypes, middlePercentage);
				self.fullPercentage = self.fullPercentage + middlePercentage;
			end;
			
			self.factorPercentage = 1/self.fullPercentage;
			
			self.middlePercentageFillTypes = {};
			for i=1, table.getn(self.mixerWagonFillTypes) do
				local absolutLevelPercentageToCapacity = self.middlePercentageLevelFillTypes[i] * self.factorPercentage;
				if absolutLevelPercentageToCapacity >= self.mixerWagonFillTypes[i].minPercentage and absolutLevelPercentageToCapacity <= self.mixerWagonFillTypes[i].maxPercentage then
					table.insert(self.middlePercentageFillTypes, absolutLevelPercentageToCapacity);
				else
					if absolutLevelPercentageToCapacity >= (self.mixerWagonFillTypes[i].minPercentage - 0.015) and absolutLevelPercentageToCapacity <= (self.mixerWagonFillTypes[i].maxPercentage + 0.015) then
						if absolutLevelPercentageToCapacity <= self.mixerWagonFillTypes[i].minPercentage then
							self.mixerWagonFillTypes[i].minPercentage = absolutLevelPercentageToCapacity - 0.001;
							table.insert(self.middlePercentageFillTypes, absolutLevelPercentageToCapacity);
						elseif absolutLevelPercentageToCapacity >= self.mixerWagonFillTypes[i].maxPercentage then
							self.mixerWagonFillTypes[i].maxPercentage = absolutLevelPercentageToCapacity + 0.001;
							table.insert(self.middlePercentageFillTypes, absolutLevelPercentageToCapacity);
						end;
					else
						self.abort = true;
					end;
				end;
			end;
			
			-- Ein absoluter Wert liegt nicht im Bereich von Min und Max, dann wird alles neu berechnet
			if self.abort then
				self.middlePercentageFillTypes = nil;
				self.middlePercentageLevelFillTypes = nil;
				self.factorPercentage = 0;
				self.fullPercentage = 0;
				
				self.middlePercentageLevelFillTypes = {};
				for i=1, table.getn(self.mixerWagonFillTypes) do
					local percentageArea = self.mixerWagonFillTypes[i].maxPercentage - self.mixerWagonFillTypes[i].minPercentage;
					if percentageArea <= 0.20 or self.mixerWagonFillTypes[i].minPercentage == 0 then
						if percentageArea <= 0.20 then
								local littlePercentageArea = (percentageArea/5) + self.mixerWagonFillTypes[i].minPercentage;
								self.fullPercentage = self.fullPercentage + littlePercentageArea
								table.insert(self.middlePercentageLevelFillTypes, littlePercentageArea);
						else
							local zeroPercentageStart = (self.mixerWagonFillTypes[i].maxPercentage - self.mixerWagonFillTypes[i].minPercentage);
								if zeroPercentageStart < 0.2 then
									zeroPercentageStart = zeroPercentageStart/1.5;
									self.fullPercentage = self.fullPercentage + zeroPercentageStart;
									table.insert(self.middlePercentageLevelFillTypes, zeroPercentageStart);
								elseif zeroPercentageStart >= 0.2 and zeroPercentageStart <= 0.35 then
									zeroPercentageStart = zeroPercentageStart/5.5;
									self.fullPercentage = self.fullPercentage + zeroPercentageStart;
									table.insert(self.middlePercentageLevelFillTypes, zeroPercentageStart);
								elseif zeroPercentageStart > 0.35 and zeroPercentageStart <= 0.7 then
									zeroPercentageStart = zeroPercentageStart/5.9;
									self.fullPercentage = self.fullPercentage + zeroPercentageStart;
									table.insert(self.middlePercentageLevelFillTypes, zeroPercentageStart);
								elseif zeroPercentageStart > 0.7 and zeroPercentageStart <= 1 then
									zeroPercentageStart = zeroPercentageStart/6;
									self.fullPercentage = self.fullPercentage + zeroPercentageStart;
									table.insert(self.middlePercentageLevelFillTypes, zeroPercentageStart);
								end;
						end;
					else
						if self.mixerWagonFillTypes[i].minPercentage <= 0.25 then
							local area = (self.mixerWagonFillTypes[i].maxPercentage - self.mixerWagonFillTypes[i].minPercentage)
								if area > 0.1 and area <= 0.4 then
									area = area;
									self.fullPercentage = self.fullPercentage + area;
									table.insert(self.middlePercentageLevelFillTypes, area);
								elseif area > 0.4 and area <= 1 then
									area = area/1.5;
									self.fullPercentage = self.fullPercentage + area;
									table.insert(self.middlePercentageLevelFillTypes, area);
								end;
						else 
							local area = (self.mixerWagonFillTypes[i].maxPercentage - self.mixerWagonFillTypes[i].minPercentage)
								if area > 0.20 and area <= 0.25 then
									area = area/1.5;
									self.fullPercentage = self.fullPercentage + area;
									table.insert(self.middlePercentageLevelFillTypes, area);
								elseif area > 0.25 and area < 0.5 then
									area = area/2;
									self.fullPercentage = self.fullPercentage + area;
									table.insert(self.middlePercentageLevelFillTypes, area);
								elseif area >= 0.5 and area <= 0.75 then
									area = area/2.5;
									self.fullPercentage = self.fullPercentage + area;
									table.insert(self.middlePercentageLevelFillTypes, area);
								end;
						end;
					end;
				end;
				
				self.factorPercentage = 1/self.fullPercentage;
				
				self.middlePercentageFillTypes = {};
				self.newMaxLevel = {};
				
				for i=1, table.getn(self.mixerWagonFillTypes) do
					local newPercentageToCapacity = self.middlePercentageLevelFillTypes[i] * self.factorPercentage;
					if newPercentageToCapacity >= self.mixerWagonFillTypes[i].minPercentage and newPercentageToCapacity <= self.mixerWagonFillTypes[i].maxPercentage then
						table.insert(self.middlePercentageFillTypes, newPercentageToCapacity);
					else
						if newPercentageToCapacity <= self.mixerWagonFillTypes[i].minPercentage then
							self.mixerWagonFillTypes[i].minPercentage = newPercentageToCapacity - 0.001;
							table.insert(self.middlePercentageFillTypes, newPercentageToCapacity);
						elseif newPercentageToCapacity >= self.mixerWagonFillTypes[i].maxPercentage then
							self.mixerWagonFillTypes[i].maxPercentage = newPercentageToCapacity + 0.001;
							table.insert(self.middlePercentageFillTypes, newPercentageToCapacity);
						end;
					end;
				end;

			end;
		end;
end;

function FFLMixerWagon:delete()
end;

function FFLMixerWagon:mouseEvent(posX, posY, isDown, isUp, button)
end;

function FFLMixerWagon:keyEvent(unicode, sym, modifier, isDown)
end;

function FFLMixerWagon:update(dt)

	if self:getIsActive() then
		if self:getIsActiveForInput() then --and self.isSelected then
			if self.fillLevel > (self.capacity * 0.02) and self.fillLevel < (self.capacity * 0.97) and self.tipState == Trailer.TIPSTATE_CLOSED then
				self.allowedHigherFillLevel = true
				if InputBinding.isPressed(InputBinding.FullFillLevel) then
					if InputBinding.hasEvent(InputBinding.FullFillLevelTwo) then
						for i=1, table.getn(self.mixerWagonFillTypes) do
							self.mixerWagonFillTypes[i].fillLevel = (self.capacity * self.middlePercentageFillTypes[i])
							self:setFillLevel(self.mixerWagonFillTypes[i].fillLevel, next(self.mixerWagonFillTypes[i].fillTypes));
						end;
					end;
				end;
				
			else
				self.allowedHigherFillLevel = false;
			end;
			
			if self.fillLevel > (self.capacity * 0.02) and self.fillLevel < self.capacity and self.tipState ~= Trailer.TIPSTATE_CLOSED and self.allowedHigherFillLevel == false then
				if InputBinding.isPressed(InputBinding.FullFillLevel) then
					if InputBinding.isPressed(InputBinding.FullFillLevelThree) then
						if InputBinding.hasEvent(InputBinding.FullFillLevelTwo) then
							for i=1, table.getn(self.mixerWagonFillTypes) do
								self.mixerWagonFillTypes[i].fillLevel = (self.capacity * self.middlePercentageFillTypes[i])
								self:setFillLevel(self.mixerWagonFillTypes[i].fillLevel, next(self.mixerWagonFillTypes[i].fillTypes));
							end;
						end;
					end;
				end;
			end;

			if self.fillLevel >= (self.capacity * 0.97) and self.fillLevel < self.capacity and self.tipState == Trailer.TIPSTATE_CLOSED and self.currentFillType == Fillable.FILLTYPE_FORAGE_MIXING then
				self.properMixtureRatio = true;
					if InputBinding.hasEvent(InputBinding.FullFillLevelTwo) then
					local factor = self.fillLevel/self.capacity
						for i=1, table.getn(self.mixerWagonFillTypes) do
							self.mixerWagonFillTypes[i].fillLevel = (self.capacity * self.middlePercentageFillTypes[i])*factor
							self:setFillLevel(self.mixerWagonFillTypes[i].fillLevel, next(self.mixerWagonFillTypes[i].fillTypes));
						end;
					end;
			else
				self.properMixtureRatio = false;
			end;
			
		end;
	end;
	
end;

function FFLMixerWagon:draw()
		if self:getIsActiveForInput() and self.allowedHigherFillLevel then --and self.isSelected then
			g_currentMission:addExtraPrintText(string.format(InputBinding.getKeyNamesOfDigitalAction(InputBinding.FullFillLevel).."".."+"..""..InputBinding.getKeyNamesOfDigitalAction(InputBinding.FullFillLevelTwo).." ".."  ".." "..(g_i18n:getText("SetFullFillLevel_2"))));
		end;
		if self:getIsActiveForInput() and self.properMixtureRatio then --and self.isSelected then
			g_currentMission:addHelpButtonText(g_i18n:getText("SetFullFillLevel_1"), InputBinding.FullFillLevelTwo)
		end;
		
end;


